' This class is "generated" and will be overwritten.
' Your customizations should be made in PersonalNameRecord.vb

Imports System.Data.SqlTypes
Imports BaseClasses
Imports BaseClasses.Data
Imports BaseClasses.Data.SqlProvider

Namespace Persons.Business

''' <summary>
''' The generated superclass for the <see cref="PersonalNameRecord"></see> class.
''' </summary>
''' <remarks>
''' This class is not intended to be instantiated directly.  To obtain an instance of this class, 
''' use the methods of the <see cref="PersonalNameTable"></see> class.
''' </remarks>
''' <seealso cref="PersonalNameTable"></seealso>
''' <seealso cref="PersonalNameRecord"></seealso>

<Serializable()> Public Class BasePersonalNameRecord
	Inherits PrimaryKeyRecord
	

	Public Shared Shadows ReadOnly TableUtils As PersonalNameTable = PersonalNameTable.Instance

	' Constructors
 
	Protected Sub New()
		MyBase.New(TableUtils)
	End Sub

	Protected Sub New(ByVal record As PrimaryKeyRecord)
		MyBase.New(record, TableUtils)
	End Sub
	
	'Evaluates Initialize when->Inserting record formulas specified at the data access layer
    Public Overridable Sub PersonalNameRecord_InsertingRecord(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles Me.InsertingRecord
        'Apply Initialize->Inserting record formula only if validation is successful.
        	        Dim PersonalNameRec As PersonalNameRecord = CType(sender,PersonalNameRecord)
        Validate_Inserting()
        If Not PersonalNameRec Is Nothing AndAlso Not PersonalNameRec.IsReadOnly Then
                End If
    End Sub

	'Evaluates Initialize when->Updating record formulas specified at the data access layer
    Public Overridable Sub PersonalNameRecord_UpdatingRecord(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles Me.UpdatingRecord
        'Apply Initialize->Updating record formula only if validation is successful.
        	        Dim PersonalNameRec As PersonalNameRecord = CType(sender,PersonalNameRecord)
        Validate_Updating()
        If Not PersonalNameRec Is Nothing AndAlso Not PersonalNameRec.IsReadOnly Then
                End If
    End Sub
    
    'Evaluates Initialize when->Reading record formulas specified at the data access layer
    Public Overridable Sub PersonalNameRecord_ReadRecord(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.ReadRecord
        'Apply Initialize->Reading record formula only if validation is successful.
        	        Dim PersonalNameRec As PersonalNameRecord = CType(sender,PersonalNameRecord)
        If Not PersonalNameRec Is Nothing AndAlso Not PersonalNameRec.IsReadOnly Then
                End If
    End Sub
    
   'Evaluates Validate when->Inserting formulas specified at the data access layer
   Public Overridable Sub Validate_Inserting ()
		Dim fullValidationMessage As String = ""
		Dim validationMessage As String = ""

		dim formula as String = ""


		If validationMessage <> "" AndAlso validationMessage.ToLower() <> "true" Then
			fullValidationMessage &= validationMessage & vbCrLf
		End If

		If fullValidationMessage <> "" Then
			Throw New Exception(fullValidationMessage)
		End If 
	End Sub
	
	'Evaluates Validate when->Updating formulas specified at the data access layer
   Public Overridable Sub Validate_Updating ()
		Dim fullValidationMessage As String = ""
		Dim validationMessage As String = ""

		dim formula as String = ""


		If validationMessage <> "" AndAlso validationMessage.ToLower() <> "true" Then
			fullValidationMessage &= validationMessage & vbCrLf
		End If

		If fullValidationMessage <> "" Then
			Throw New Exception(fullValidationMessage)
		End If 
	End Sub
 
	Public Overridable Function EvaluateFormula(ByVal formula As String, Optional ByVal dataSourceForEvaluate As BaseClasses.Data.BaseRecord = Nothing, Optional ByVal format As String = Nothing) As String

		Dim e As Data.BaseFormulaEvaluator = New Data.BaseFormulaEvaluator()

            ' All variables referred to in the formula are expected to be
            ' properties of the DataSource.  For example, referring to
            ' UnitPrice as a variable will refer to DataSource.UnitPrice
            e.DataSource = dataSourceForEvaluate

            Dim resultObj As Object = e.Evaluate(formula)
            If resultObj Is Nothing Then
                Return ""
            End If
        	Return resultObj.ToString()
	End Function







#Region "Convenience methods to get/set values of fields"

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's PersonalName_.id field.
	''' </summary>
	Public Function Getid0Value() As ColumnValue
		Return Me.GetValue(TableUtils.id0Column)
	End Function

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's PersonalName_.id field.
	''' </summary>
	Public Function Getid0FieldValue() As Int32
		Return CType(Me.GetValue(TableUtils.id0Column).ToInt32(), Int32)
	End Function

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's PersonalName_.PersonalId field.
	''' </summary>
	Public Function GetPersonalIdValue() As ColumnValue
		Return Me.GetValue(TableUtils.PersonalIdColumn)
	End Function

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's PersonalName_.PersonalId field.
	''' </summary>
	Public Function GetPersonalIdFieldValue() As String
		Return CType(Me.GetValue(TableUtils.PersonalIdColumn).ToString(), String)
	End Function

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's PersonalName_.PersonalId field.
	''' </summary>
	Public Sub SetPersonalIdFieldValue(ByVal val As ColumnValue)
		Me.SetValue(val, TableUtils.PersonalIdColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's PersonalName_.PersonalId field.
	''' </summary>
	Public Sub SetPersonalIdFieldValue(ByVal val As String)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.PersonalIdColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's PersonalName_.PersonalName field.
	''' </summary>
	Public Function GetPersonalNameValue() As ColumnValue
		Return Me.GetValue(TableUtils.PersonalNameColumn)
	End Function

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's PersonalName_.PersonalName field.
	''' </summary>
	Public Function GetPersonalNameFieldValue() As String
		Return CType(Me.GetValue(TableUtils.PersonalNameColumn).ToString(), String)
	End Function

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's PersonalName_.PersonalName field.
	''' </summary>
	Public Sub SetPersonalNameFieldValue(ByVal val As ColumnValue)
		Me.SetValue(val, TableUtils.PersonalNameColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's PersonalName_.PersonalName field.
	''' </summary>
	Public Sub SetPersonalNameFieldValue(ByVal val As String)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.PersonalNameColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's PersonalName_.PersonalLastName field.
	''' </summary>
	Public Function GetPersonalLastNameValue() As ColumnValue
		Return Me.GetValue(TableUtils.PersonalLastNameColumn)
	End Function

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's PersonalName_.PersonalLastName field.
	''' </summary>
	Public Function GetPersonalLastNameFieldValue() As String
		Return CType(Me.GetValue(TableUtils.PersonalLastNameColumn).ToString(), String)
	End Function

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's PersonalName_.PersonalLastName field.
	''' </summary>
	Public Sub SetPersonalLastNameFieldValue(ByVal val As ColumnValue)
		Me.SetValue(val, TableUtils.PersonalLastNameColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's PersonalName_.PersonalLastName field.
	''' </summary>
	Public Sub SetPersonalLastNameFieldValue(ByVal val As String)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.PersonalLastNameColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's PersonalName_.NameDate field.
	''' </summary>
	Public Function GetNameDateValue() As ColumnValue
		Return Me.GetValue(TableUtils.NameDateColumn)
	End Function

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's PersonalName_.NameDate field.
	''' </summary>
	Public Function GetNameDateFieldValue() As DateTime
		Return CType(Me.GetValue(TableUtils.NameDateColumn).ToDateTime(), DateTime)
	End Function

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's PersonalName_.NameDate field.
	''' </summary>
	Public Sub SetNameDateFieldValue(ByVal val As ColumnValue)
		Me.SetValue(val, TableUtils.NameDateColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's PersonalName_.NameDate field.
	''' </summary>
	Public Sub SetNameDateFieldValue(ByVal val As String)
		Me.SetString(val, TableUtils.NameDateColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's PersonalName_.NameDate field.
	''' </summary>
	Public Sub SetNameDateFieldValue(ByVal val As DateTime)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.NameDateColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's PersonalName_.Ref field.
	''' </summary>
	Public Function GetRef0Value() As ColumnValue
		Return Me.GetValue(TableUtils.Ref0Column)
	End Function

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's PersonalName_.Ref field.
	''' </summary>
	Public Function GetRef0FieldValue() As String
		Return CType(Me.GetValue(TableUtils.Ref0Column).ToString(), String)
	End Function

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's PersonalName_.Ref field.
	''' </summary>
	Public Sub SetRef0FieldValue(ByVal val As ColumnValue)
		Me.SetValue(val, TableUtils.Ref0Column)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's PersonalName_.Ref field.
	''' </summary>
	Public Sub SetRef0FieldValue(ByVal val As String)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.Ref0Column)
	End Sub



#End Region

#Region "Convenience methods to get field names"

	''' <summary>
	''' This is a convenience property that provides direct access to the value of the record's PersonalName_.id field.
	''' </summary>
	Public Property id0() As Int32
		Get 
			Return CType(Me.GetValue(TableUtils.id0Column).ToInt32(), Int32)
		End Get
		Set (ByVal val As Int32) 
			Dim colValue As ColumnValue = New ColumnValue(val)
			Me.SetValue(colValue, TableUtils.id0Column)
		End Set
	End Property


	''' <summary>
	''' This is a convenience method that can be used to determine that the column is set.
	''' </summary>
	Public ReadOnly Property id0Specified() As Boolean
        Get
            Dim val As ColumnValue = Me.GetValue(TableUtils.id0Column)
            If val Is Nothing OrElse val.IsNull Then
                Return False
            End If
            Return True
        End Get
    End Property

	''' <summary>
	''' This is a convenience method that can be used to get the default value of a column.
	''' </summary>
    Public ReadOnly Property id0Default() As String
        Get
            Return TableUtils.id0Column.DefaultValue
        End Get
    End Property

	''' <summary>
	''' This is a convenience property that provides direct access to the value of the record's PersonalName_.PersonalId field.
	''' </summary>
	Public Property PersonalId() As String
		Get 
			Return CType(Me.GetValue(TableUtils.PersonalIdColumn).ToString(), String)
		End Get
		Set (ByVal Value As String) 
			Me.SetString(value, TableUtils.PersonalIdColumn)
		End Set
	End Property


	''' <summary>
	''' This is a convenience method that can be used to determine that the column is set.
	''' </summary>
	Public ReadOnly Property PersonalIdSpecified() As Boolean
        Get
            Dim val As ColumnValue = Me.GetValue(TableUtils.PersonalIdColumn)
            If val Is Nothing OrElse val.IsNull Then
                Return False
            End If
            Return True
        End Get
    End Property

	''' <summary>
	''' This is a convenience method that can be used to get the default value of a column.
	''' </summary>
    Public ReadOnly Property PersonalIdDefault() As String
        Get
            Return TableUtils.PersonalIdColumn.DefaultValue
        End Get
    End Property

	''' <summary>
	''' This is a convenience property that provides direct access to the value of the record's PersonalName_.PersonalName field.
	''' </summary>
	Public Property PersonalName() As String
		Get 
			Return CType(Me.GetValue(TableUtils.PersonalNameColumn).ToString(), String)
		End Get
		Set (ByVal Value As String) 
			Me.SetString(value, TableUtils.PersonalNameColumn)
		End Set
	End Property


	''' <summary>
	''' This is a convenience method that can be used to determine that the column is set.
	''' </summary>
	Public ReadOnly Property PersonalNameSpecified() As Boolean
        Get
            Dim val As ColumnValue = Me.GetValue(TableUtils.PersonalNameColumn)
            If val Is Nothing OrElse val.IsNull Then
                Return False
            End If
            Return True
        End Get
    End Property

	''' <summary>
	''' This is a convenience method that can be used to get the default value of a column.
	''' </summary>
    Public ReadOnly Property PersonalNameDefault() As String
        Get
            Return TableUtils.PersonalNameColumn.DefaultValue
        End Get
    End Property

	''' <summary>
	''' This is a convenience property that provides direct access to the value of the record's PersonalName_.PersonalLastName field.
	''' </summary>
	Public Property PersonalLastName() As String
		Get 
			Return CType(Me.GetValue(TableUtils.PersonalLastNameColumn).ToString(), String)
		End Get
		Set (ByVal Value As String) 
			Me.SetString(value, TableUtils.PersonalLastNameColumn)
		End Set
	End Property


	''' <summary>
	''' This is a convenience method that can be used to determine that the column is set.
	''' </summary>
	Public ReadOnly Property PersonalLastNameSpecified() As Boolean
        Get
            Dim val As ColumnValue = Me.GetValue(TableUtils.PersonalLastNameColumn)
            If val Is Nothing OrElse val.IsNull Then
                Return False
            End If
            Return True
        End Get
    End Property

	''' <summary>
	''' This is a convenience method that can be used to get the default value of a column.
	''' </summary>
    Public ReadOnly Property PersonalLastNameDefault() As String
        Get
            Return TableUtils.PersonalLastNameColumn.DefaultValue
        End Get
    End Property

	''' <summary>
	''' This is a convenience property that provides direct access to the value of the record's PersonalName_.NameDate field.
	''' </summary>
	Public Property NameDate() As DateTime
		Get 
			Return CType(Me.GetValue(TableUtils.NameDateColumn).ToDateTime(), DateTime)
		End Get
		Set (ByVal val As DateTime) 
			Dim colValue As ColumnValue = New ColumnValue(val)
			Me.SetValue(colValue, TableUtils.NameDateColumn)
		End Set
	End Property


	''' <summary>
	''' This is a convenience method that can be used to determine that the column is set.
	''' </summary>
	Public ReadOnly Property NameDateSpecified() As Boolean
        Get
            Dim val As ColumnValue = Me.GetValue(TableUtils.NameDateColumn)
            If val Is Nothing OrElse val.IsNull Then
                Return False
            End If
            Return True
        End Get
    End Property

	''' <summary>
	''' This is a convenience method that can be used to get the default value of a column.
	''' </summary>
    Public ReadOnly Property NameDateDefault() As String
        Get
            Return TableUtils.NameDateColumn.DefaultValue
        End Get
    End Property

	''' <summary>
	''' This is a convenience property that provides direct access to the value of the record's PersonalName_.Ref field.
	''' </summary>
	Public Property Ref0() As String
		Get 
			Return CType(Me.GetValue(TableUtils.Ref0Column).ToString(), String)
		End Get
		Set (ByVal Value As String) 
			Me.SetString(value, TableUtils.Ref0Column)
		End Set
	End Property


	''' <summary>
	''' This is a convenience method that can be used to determine that the column is set.
	''' </summary>
	Public ReadOnly Property Ref0Specified() As Boolean
        Get
            Dim val As ColumnValue = Me.GetValue(TableUtils.Ref0Column)
            If val Is Nothing OrElse val.IsNull Then
                Return False
            End If
            Return True
        End Get
    End Property

	''' <summary>
	''' This is a convenience method that can be used to get the default value of a column.
	''' </summary>
    Public ReadOnly Property Ref0Default() As String
        Get
            Return TableUtils.Ref0Column.DefaultValue
        End Get
    End Property



#End Region

End Class
End Namespace
